Subject: Automake, Libtool and AM_PROG_AR (was: Re: bug#11401: automake-1.12 (incorrectly?) complains about missing AM_PROG_AR)

From: Stefano Lattarini <[email-masked]>
Date: Wed, 21 Nov 2012 11:46:50 +0100

References:
<http://debbugs.gnu.org/cgi/bugreport.cgi?bug=11401>
<http://lists.gnu.org/archive/html/automake/2012-05/msg00012.html>

On 05/11/2012 01:37 PM, Stefano Lattarini wrote:
> On 05/04/2012 09:19 PM, Mike Frysinger wrote:
>> On Friday 04 May 2012 03:20:10 Peter Rosin wrote:
>>> On 2012-05-04 07:25, Mike Frysinger wrote:
>>>>
>>>> $ cat configure.ac
>>>> AC_PREREQ([2.63])
>>>> AC_INIT([foo], [0])
>>>> AM_INIT_AUTOMAKE([1.11 -Wall foreign])
>>>> AC_PROG_CC
>>>> LT_INIT
>>>> AC_OUTPUT(Makefile)
>>>>
>>>> $ cat Makefile.am
>>>> lib_LTLIBRARIES = libfoo.la
>>>> libfoo_la_SOURCES = foo.c
>>>>
>>>> with automake-1.11.5, everything works great, but with automake 1.12:
>>>>
>>>> $ autoreconf -f -i
>>>>> ...
>>>> ltlibrary.am: warning: 'libfoo.la': linking libtool libraries using a non-POSIX
>>>> ltlibrary.am: archiver requires 'AM_PROG_AR' in 'configure.ac'
>>>> Makefile.am:1:   while processing Libtool library 'libfoo.la'
>>>>
>>>> what gives ?
>>>
>>> If you don't want *all* warnings, don't ask for *all* warnings :-)
>>
>> not my code base ;)
>>
>>> It's in NEWS, from 1.12:
>>>
>>>   - The warnings in the category 'extra-portability' are now enabled by
>>>     '-Wall'.  In previous versions, one has to use '-Wextra-portability'
>>>     to enable them.
>>
>> ok, so the fact that it's warning via -Wall is new to 1.12, but the underlying 
>> issue (warning at all) is not
>>
> Exactly.
> 
>>> which should be read in light of this from 1.11.2:
>>>
>>>   - New macro AM_PROG_AR that looks for an archiver and wraps it in the new
>>>     'ar-lib' auxiliary script if the selected archiver is Microsoft lib.
>>>     This new macro is required for LIBRARIES and LTLIBRARIES when automake
>>>     is run with -Wextra-portability and -Werror.
>>
>> imo, projects utilizing libtool shouldn't need to know this at all.  the whole 
>> point is to hide these esoteric details behind a layer and focus on the bits 
>> that projects actually care about -- what sources to put into libraries, 
>> etc...  so is the answer to update libtool to call AM_PROG_AR when it's 
>> available ?
>>
> It seems there might be consensus on this idea:
> 
>   <http://lists.gnu.org/archive/html/automake/2012-05/msg00012.html>
> 
> If it will turn out that is actually the case, I will close this bug report
> (the discussion will likely continue on the bug-libtool list).  For now, let's
> wait and see how things evolve.
>
Any news on this?  Since it doesn't seem a big deal anyway, unless I hear
something new in a few days, I'll go ahead and close the bug report, leaving
the matter in the hands of the libtoolers.

Regards,
  Stefano